package org.gcube.portlets.user.geoportaldataviewer.client.ui.images;

import org.gcube.application.geoportalcommon.shared.products.model.UploadedImageDV;
import org.gcube.portlets.user.geoportaldataviewer.client.util.StringUtil;

import com.google.gwt.core.client.GWT;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTMLPanel;
import com.google.gwt.user.client.ui.Widget;


/**
 * The Class ThumbnailImageView.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR (francesco.mangiacrapa@isti.cnr.it)
 * 
 * Nov 20, 2020
 */
public class ThumbnailImageView extends Composite {

	private static ThumbnailImageViewUiBinder uiBinder = GWT.create(ThumbnailImageViewUiBinder.class);

	@UiField
	HTMLPanel thumbnailContainer;
	/**
	 * The Interface ThumbnailImageViewUiBinder.
	 *
	 * @author Francesco Mangiacrapa at ISTI-CNR (francesco.mangiacrapa@isti.cnr.it)
	 * 
	 * Nov 20, 2020
	 */
	interface ThumbnailImageViewUiBinder extends UiBinder<Widget, ThumbnailImageView> {
	}

	/**
	 * Instantiates a new thumbnail image view.
	 *
	 * @param imageDV the image DV
	 * @param showView the show view
	 * @param showOpen the show open
	 */
	public ThumbnailImageView(UploadedImageDV imageDV, final boolean showView, final boolean showOpen) {
		initWidget(uiBinder.createAndBindUi(this));
		
		ImageView imageView = new ImageView(imageDV, showView, showOpen);
		String title = StringUtil.ellipsize(imageDV.getTitolo(), 25);
		imageView.setHeading(title);
		
		String didascalia = StringUtil.ellipsize(imageDV.getDidascalia(), 50);
		imageView.setParagraph(didascalia);
		
//		imageView.setViewImageVisible(true);
		
		thumbnailContainer.add(imageView);

	}


}
