package org.gcube.portlets.user.geoportaldataviewer.shared.gis;

import java.io.Serializable;

/**
 * The Class LayerObject.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR (francesco.mangiacrapa@isti.cnr.it)
 * 
 *         Nov 13, 2020
 */
public class LayerObject implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2282478701630148774L;
	/* This is the layer/product type. E.g. Concessione */
	private String itemType;
	private LayerItem layerItem;

	/**
	 * Instantiates a new layer object.
	 */
	public LayerObject() {
	}

	public LayerObject(String itemType, LayerItem layerItem) {
		super();
		this.itemType = itemType;
		this.layerItem = layerItem;
	}

	/**
	 * Gets the item type.
	 *
	 * @return the item type
	 */
	public String getItemType() {
		return itemType;
	}

	/**
	 * Sets the item type.
	 *
	 * @param itemType the new item type
	 */
	public void setItemType(String itemType) {
		this.itemType = itemType;
	}

	/**
	 * Gets the layer item.
	 *
	 * @return the layer item
	 */
	public LayerItem getLayerItem() {
		return layerItem;
	}

	/**
	 * Sets the layer item.
	 *
	 * @param layerItem the new layer item
	 */
	public void setLayerItem(LayerItem layerItem) {
		this.layerItem = layerItem;
	}

	/**
	 * To string.
	 *
	 * @return the string
	 */
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("LayerObject [itemType=");
		builder.append(itemType);
		builder.append(", layerItem=");
		builder.append(layerItem);
		builder.append("]");
		return builder.toString();
	}

}
